/* Copyright (c) 2012 Nordic Semiconductor. All Rights Reserved.
 *
 * The information contained herein is property of Nordic Semiconductor ASA.
 * Terms and conditions of usage are described in detail in NORDIC
 * SEMICONDUCTOR STANDARD SOFTWARE LICENSE AGREEMENT.
 *
 * Licensees are granted free, non-transferable use of the information. NO
 * WARRANTY of ANY KIND is provided. This heading must NOT be removed from
 * the file.
 *
 */

/** @file
 *
 * @defgroup ble_sdk_uart_over_ble_main main.c
 * @{
 * @ingroup  ble_sdk_app_nus_eval
 * @brief    UART over BLE application main file.
 *
 * This file contains the source code for a sample application that uses the Nordic UART service.
 * This application uses the @ref srvlib_conn_params module.
 */

#include <stdint.h>
#include <string.h>
#include "nordic_common.h"
#include "nrf.h"
#include "nrf51_bitfields.h"
#include "ble_hci.h"
#include "ble_advdata.h"
#include "ble_conn_params.h"
#include "softdevice_handler.h"
#include "app_timer.h"
#include "app_button.h"
#include "ble_nus.h"
#include "simple_uart.h"
#include "boards.h"
#include "ble_error_log.h"
#include "ble_debug_assert_handler.h"
#include "pstorage_platform.h"
#include "pstorage.h"
#include "nrf_delay.h"
#include "nrf_gpiote.h"
#include "app_gpiote.h"

//#define WAKEUP_BUTTON_PIN               BUTTON_0                                    /**< Button used to wake up the application. */

#define ADVERTISING_LED_PIN_NO          LED_0                                       /**< LED to indicate advertising state. */
#define CONNECTED_LED_PIN_NO            LED_1                                       /**< LED to indicate connected state. */

#define DEVICE_NAME                     "WANG-DOCK"
																																										/**< Name of device. Will be included in the advertising data. */

#define APP_ADV_INTERVAL                64                                          /**< The advertising interval (in units of 0.625 ms. This value corresponds to 40 ms). */
#define APP_ADV_TIMEOUT_IN_SECONDS      180                                         /**< The advertising timeout (in units of seconds). */

#define APP_TIMER_PRESCALER             0                                           /**< Value of the RTC1 PRESCALER register. */
#define APP_TIMER_MAX_TIMERS            2                                           /**< Maximum number of simultaneously created timers. */
#define APP_TIMER_OP_QUEUE_SIZE         4                                           /**< Size of timer operation queues. */

#define MIN_CONN_INTERVAL               16                                          /**< Minimum acceptable connection interval (20 ms), Connection interval uses 1.25 ms units. */
#define MAX_CONN_INTERVAL               60                                          /**< Maximum acceptable connection interval (75 ms), Connection interval uses 1.25 ms units. */
#define SLAVE_LATENCY                   0                                           /**< slave latency. */
#define CONN_SUP_TIMEOUT                400                                         /**< Connection supervisory timeout (4 seconds), Supervision Timeout uses 10 ms units. */
#define FIRST_CONN_PARAMS_UPDATE_DELAY  APP_TIMER_TICKS(20000, APP_TIMER_PRESCALER) /**< Time from initiating event (connect or start of notification) to first time sd_ble_gap_conn_param_update is called (20 seconds). */
#define NEXT_CONN_PARAMS_UPDATE_DELAY   APP_TIMER_TICKS(5000, APP_TIMER_PRESCALER)  /**< Time between each call to sd_ble_gap_conn_param_update after the first call (5 seconds). */
#define MAX_CONN_PARAMS_UPDATE_COUNT    3                                           /**< Number of attempts before giving up the connection parameter negotiation. */

#define BUTTON_DETECTION_DELAY          APP_TIMER_TICKS(50, APP_TIMER_PRESCALER)    /**< Delay from a GPIOTE event until a button is reported as pushed (in number of timer ticks). */

#define SEC_PARAM_TIMEOUT               30                                          /**< Timeout for Pairing Request or Security Request (in seconds). */
#define SEC_PARAM_BOND                  1                                           /**< Perform bonding. */
#define SEC_PARAM_MITM                  0                                           /**< Man In The Middle protection not required. */
#define SEC_PARAM_IO_CAPABILITIES       BLE_GAP_IO_CAPS_NONE                        /**< No I/O capabilities. */
#define SEC_PARAM_OOB                   0                                           /**< Out Of Band data not available. */
#define SEC_PARAM_MIN_KEY_SIZE          7                                           /**< Minimum encryption key size. */
#define SEC_PARAM_MAX_KEY_SIZE          16                                          /**< Maximum encryption key size. */

#define START_STRING                    "application Start... \r\n"                                /**< The string that will be sent over the UART when the application starts. */
static bool                             m_advertising_start_pending = false; /**< Flag to keep track of ongoing operations on persistent memory. */
#define DEAD_BEEF                       0xDEADBEEF                                  /**< Value used as error code on stack dump, can be used to identify stack location on stack unwind. */
static bool                               m_memory_access_in_progress = false;
static ble_gap_sec_params_t             m_sec_params;                               /**< Security requirements for this application. */
static uint16_t                         m_conn_handle = BLE_CONN_HANDLE_INVALID;    /**< Handle of the current connection. */
static ble_nus_t                        m_nus;                                      /**< Structure to identify the Nordic UART Service. */
typedef struct
{
    uint8_t               val[40];   /**< If bank is valid, this field will contain a valid CRC of the image. */
} bootloader_settings_t;
bootloader_settings_t 	bootloader_settings;

bool 	update =0;
int 	update_count;
int  	cash_status;
uint8_t 	cash_control = 0;

uint8_t TIMER1_200ms_counter =0;
uint8_t TIMER1_500ms_counter =0;
uint8_t TIMER1_1000ms_counter =0;
uint32_t SystemTimer=0;
uint16_t led_on_time;
uint16_t led_flash_time;

uint8_t csum(uint8_t *addr, uint8_t count);
void update_ack(int num);
void cash_control_for(void);
void setting_init(void);
void button_handle(void);
void cash_status_ack(void );

void led_on(uint16_t delay_s);
void led_flash(uint16_t delay_s);
static void button_event_handler(uint8_t pin_no, uint8_t button_action);
/**@brief     Error handler function, which is called when an error has occurred.
 *
 * @warning   This handler is an example only and does not fit a final product. You need to analyze
 *            how your product is supposed to react in case of error.
 *
 * @param[in] error_code  Error code supplied to the handler.
 * @param[in] line_num    Line number where the handler is called.
 * @param[in] p_file_name Pointer to the file name. 
 */
void app_error_handler(uint32_t error_code, uint32_t line_num, const uint8_t * p_file_name)
{
    // This call can be used for debug purposes during application development.
    // @note CAUTION: Activating this code will write the stack to flash on an error.
    //                This function should NOT be used in a final product.
    //                It is intended STRICTLY for development/debugging purposes.
    //                The flash write will happen EVEN if the radio is active, thus interrupting
    //                any communication.
    //                Use with care. Un-comment the line below to use.
    // ble_debug_assert_handler(error_code, line_num, p_file_name);

    // On assert, the system can only recover with a reset.
    NVIC_SystemReset();
}


/**@brief       Assert macro callback function.
 *
 * @details     This function will be called in case of an assert in the SoftDevice.
 *
 * @warning     This handler is an example only and does not fit a final product. You need to
 *              analyze how your product is supposed to react in case of Assert.
 * @warning     On assert from the SoftDevice, the system can only recover on reset.
 *
 * @param[in]   line_num   Line number of the failing ASSERT call.
 * @param[in]   file_name  File name of the failing ASSERT call.
 */
void assert_nrf_callback(uint16_t line_num, const uint8_t * p_file_name)
{
    app_error_handler(DEAD_BEEF, line_num, p_file_name);
}


/**@brief   Function for the LEDs initialization.
 *
 * @details Initializes all LEDs used by this application.
 */
static void leds_init(void)
{
    //nrf_gpio_cfg_output(ADVERTISING_LED_PIN_NO);
    //nrf_gpio_cfg_output(CONNECTED_LED_PIN_NO);
	nrf_gpio_cfg_output(3);
	nrf_gpio_cfg_output(1);
	nrf_gpio_cfg_output(2);
	//nrf_gpio_pin_set(3);
	nrf_gpio_pin_set(1);
	//nrf_gpio_pin_set(2);
}


/**@brief   Function for Timer initialization.
 *
 * @details Initializes the timer module.
 */
static void timers_init(void)
{
    // Initialize timer module
    APP_TIMER_INIT(APP_TIMER_PRESCALER, APP_TIMER_MAX_TIMERS, APP_TIMER_OP_QUEUE_SIZE, false);
}


/**@brief   Function for the GAP initialization.
 *
 * @details This function will setup all the necessary GAP (Generic Access Profile)
 *          parameters of the device. It also sets the permissions and appearance.
 */
static void gap_params_init(void)
{
    uint32_t                err_code;
    ble_gap_conn_params_t   gap_conn_params;
    ble_gap_conn_sec_mode_t sec_mode;

    BLE_GAP_CONN_SEC_MODE_SET_OPEN(&sec_mode);
    
//    err_code = sd_ble_gap_device_name_set(&sec_mode,
//                                          (const uint8_t *) DEVICE_NAME,
//                                          strlen(DEVICE_NAME));
		
		err_code = sd_ble_gap_device_name_set(&sec_mode,
																						(const uint8_t *) (&bootloader_settings.val[0]),
																						16);
    APP_ERROR_CHECK(err_code);

    memset(&gap_conn_params, 0, sizeof(gap_conn_params));

    gap_conn_params.min_conn_interval = MIN_CONN_INTERVAL;
    gap_conn_params.max_conn_interval = MAX_CONN_INTERVAL;
    gap_conn_params.slave_latency     = SLAVE_LATENCY;
    gap_conn_params.conn_sup_timeout  = CONN_SUP_TIMEOUT;

    err_code = sd_ble_gap_ppcp_set(&gap_conn_params);
    APP_ERROR_CHECK(err_code);
}


/**@brief   Function for the Advertising functionality initialization.
 *
 * @details Encodes the required advertising data and passes it to the stack.
 *          Also builds a structure to be passed to the stack when starting advertising.
 */
static void advertising_init(void)
{
    uint32_t      err_code;
    ble_advdata_t advdata;
    ble_advdata_t scanrsp;
    uint8_t       flags = BLE_GAP_ADV_FLAGS_LE_ONLY_LIMITED_DISC_MODE;
    
    ble_uuid_t adv_uuids[] = {{BLE_UUID_NUS_SERVICE, m_nus.uuid_type}};

    memset(&advdata, 0, sizeof(advdata));
    advdata.name_type               = BLE_ADVDATA_FULL_NAME;
    advdata.include_appearance      = false;
    advdata.flags.size              = sizeof(flags);
    advdata.flags.p_data            = &flags;

    memset(&scanrsp, 0, sizeof(scanrsp));
    scanrsp.uuids_complete.uuid_cnt = sizeof(adv_uuids) / sizeof(adv_uuids[0]);
    scanrsp.uuids_complete.p_uuids  = adv_uuids;
    
    err_code = ble_advdata_set(&advdata, &scanrsp);
    APP_ERROR_CHECK(err_code);
}


/**@brief    Function for handling the data from the Nordic UART Service.
 *
 * @details  This function will process the data received from the Nordic UART BLE Service and send
 *           it to the UART module.
 */
/**@snippet [Handling the data received over BLE] */
void nus_data_handler(ble_nus_t * p_nus, uint8_t * p_data, uint16_t length)
{
//		uint8_t val,len,sum;
//		uint16_t bage_num;
//		uint8_t * pd;
//		
//		
		for (int i = 0; i < length; i++)
		{
					simple_uart_put(p_data[i]);
		}
		simple_uart_putstring((const uint8_t *) "\r\n");
//		
//		val =length>>8;
//		simple_uart_put(val);
//		val =length;
//		simple_uart_put(val);
//		
//		if(length>20)return;
//		
//		val = p_data[0]&0xA0;
//		if(val != 0xA0)return;
//		simple_uart_putstring((const uint8_t *) "test 0\r\n");
//		len 			= p_data[0]&0x1F;
//		bage_num 	= p_data[1];
//		bage_num 	= ((bage_num<<8) + p_data[2]);
//		sum 			= p_data[3+len];
//		pd 				= p_data+3;
//		simple_uart_putstring((const uint8_t *) "test 1\r\n");
//		val =csum(p_data,len+3);
//		if(val != sum) 
//		{
//			 simple_uart_putstring((const uint8_t *) "recv sum error \r\n");
//			 return;
//		}

//		for (int i = 0; i < length; i++)
//		{
//					simple_uart_put(p_data[i]);
//		}
//		simple_uart_putstring((const uint8_t *) "\r\n");
//		
//		
//		if(0) // if(update == true)
//		{
//				if(bage_num == 0xFFFF)
//				{
//						if((pd[0] == 'u')&&(pd[1] == 'p')&&(pd[2] == 'o')&&(pd[3] == 'k'))
//						{  
//							update =false;
//							update_count =0;
//							if(pd[4])simple_uart_putstring((const uint8_t *) "update ok\r\n");
//							else simple_uart_putstring((const uint8_t *) "update error\r\n");
//							
//							update_ack(0);//回复ACK;
//						}
//				}	
//				else if((bage_num&0x000F) == update_count)
//				{
//								for (int i = 0; i < length; i++)
//								{
//											simple_uart_put(pd[i]);
//								}
//								simple_uart_putstring((const uint8_t *) "\r\n");

//								if(update_count==0x00)simple_uart_putstring((const uint8_t *) "write flash \r\n");
//								
//								update_count++;
//								update_count = update_count &0x000f;
//								
//								update_ack(bage_num);//回复ACK;
//				}
//		}
//		else if((pd[0] == 'u')&&(pd[1] == 'p')&&(pd[2] == 'd')&&(pd[3] == 'a'))
//		{
//			
//			update =true;
//				update_count =0;
//				update_ack(bage_num);//回复ACK;
//				simple_uart_putstring((const uint8_t *) "recv update start \r\n");

//			
//		}
//		else if((pd[0] == 'o')&&(pd[1] == 'p')&&(pd[2] == 'e')&&(pd[3] == 'n'))
//		{
//					simple_uart_putstring((const uint8_t *) "recv open cmd \r\n");
//		}

		if((p_data[0] == 'o')&&(p_data[1] == 'p')&&(p_data[2] == 'e')&&(p_data[3] == 'n'))
		{
					simple_uart_putstring((const uint8_t *) "recv open cmd \r\n");
					cash_control =1;
		}
		if((p_data[0] == 's')&&(p_data[1] == 't')&&(p_data[2] == 'a')&&(p_data[3] == 'u'))
		{
					simple_uart_putstring((const uint8_t *) "recv status cmd \r\n");
					cash_status_ack();
		}
}
/**@snippet [Handling the data received over BLE] */


/**@brief Function for initializing services that will be used by the application.
 */
static void services_init(void)
{
    uint32_t         err_code;
    ble_nus_init_t   nus_init;
    
    memset(&nus_init, 0, sizeof(nus_init));

    nus_init.data_handler = nus_data_handler;
    
    err_code = ble_nus_init(&m_nus, &nus_init);
    APP_ERROR_CHECK(err_code);
}


/**@brief Function for initializing security parameters.
 */
static void sec_params_init(void)
{
    m_sec_params.timeout      = SEC_PARAM_TIMEOUT;
    m_sec_params.bond         = SEC_PARAM_BOND;
    m_sec_params.mitm         = SEC_PARAM_MITM;
    m_sec_params.io_caps      = SEC_PARAM_IO_CAPABILITIES;
    m_sec_params.oob          = SEC_PARAM_OOB;  
    m_sec_params.min_key_size = SEC_PARAM_MIN_KEY_SIZE;
    m_sec_params.max_key_size = SEC_PARAM_MAX_KEY_SIZE;
}


/**@brief       Function for handling an event from the Connection Parameters Module.
 *
 * @details     This function will be called for all events in the Connection Parameters Module
 *              which are passed to the application.
 *
 * @note        All this function does is to disconnect. This could have been done by simply setting
 *              the disconnect_on_fail config parameter, but instead we use the event handler
 *              mechanism to demonstrate its use.
 *
 * @param[in]   p_evt   Event received from the Connection Parameters Module.
 */
static void on_conn_params_evt(ble_conn_params_evt_t * p_evt)
{
    uint32_t err_code;
    
    if(p_evt->evt_type == BLE_CONN_PARAMS_EVT_FAILED)
    {
        err_code = sd_ble_gap_disconnect(m_conn_handle, BLE_HCI_CONN_INTERVAL_UNACCEPTABLE);
        APP_ERROR_CHECK(err_code);
    }
}


/**@brief       Function for handling errors from the Connection Parameters module.
 *
 * @param[in]   nrf_error   Error code containing information about what went wrong.
 */
static void conn_params_error_handler(uint32_t nrf_error)
{
    APP_ERROR_HANDLER(nrf_error);
}


/**@brief Function for initializing the Connection Parameters module.
 */
static void conn_params_init(void)
{
    uint32_t               err_code;
    ble_conn_params_init_t cp_init;
    
    memset(&cp_init, 0, sizeof(cp_init));

    cp_init.p_conn_params                  = NULL;
    cp_init.first_conn_params_update_delay = FIRST_CONN_PARAMS_UPDATE_DELAY;
    cp_init.next_conn_params_update_delay  = NEXT_CONN_PARAMS_UPDATE_DELAY;
    cp_init.max_conn_params_update_count   = MAX_CONN_PARAMS_UPDATE_COUNT;
    cp_init.start_on_notify_cccd_handle    = BLE_GATT_HANDLE_INVALID;
    cp_init.disconnect_on_fail             = false;
    cp_init.evt_handler                    = on_conn_params_evt;
    cp_init.error_handler                  = conn_params_error_handler;
    
    err_code = ble_conn_params_init(&cp_init);
    APP_ERROR_CHECK(err_code);
}


/**@brief Function for starting advertising.
 */
static void advertising_start(void)
{
    uint32_t             err_code;
    ble_gap_adv_params_t adv_params;
		
    // Start advertising
    memset(&adv_params, 0, sizeof(adv_params));
    
    adv_params.type        = BLE_GAP_ADV_TYPE_ADV_IND;
    adv_params.p_peer_addr = NULL;
    adv_params.fp          = BLE_GAP_ADV_FP_ANY;
    adv_params.interval    = APP_ADV_INTERVAL;
    adv_params.timeout     = APP_ADV_TIMEOUT_IN_SECONDS;

    err_code = sd_ble_gap_adv_start(&adv_params);
    APP_ERROR_CHECK(err_code);

    nrf_gpio_pin_set(ADVERTISING_LED_PIN_NO);
}


/**@brief       Function for the Application's S110 SoftDevice event handler.
 *
 * @param[in]   p_ble_evt   S110 SoftDevice event.
 */
static void on_ble_evt(ble_evt_t * p_ble_evt)
{
    uint32_t                         err_code;
    static ble_gap_evt_auth_status_t m_auth_status;
    ble_gap_enc_info_t *             p_enc_info;
    
    switch (p_ble_evt->header.evt_id)
    {
        case BLE_GAP_EVT_CONNECTED:
            nrf_gpio_pin_set(CONNECTED_LED_PIN_NO);
            nrf_gpio_pin_clear(ADVERTISING_LED_PIN_NO);
            m_conn_handle = p_ble_evt->evt.gap_evt.conn_handle;
						led_on(3);
            break;
            
        case BLE_GAP_EVT_DISCONNECTED:
            nrf_gpio_pin_clear(CONNECTED_LED_PIN_NO);
            m_conn_handle = BLE_CONN_HANDLE_INVALID;
						led_flash(3);
            advertising_start();

            break;
            
        case BLE_GAP_EVT_SEC_PARAMS_REQUEST:
            err_code = sd_ble_gap_sec_params_reply(m_conn_handle, 
                                                   BLE_GAP_SEC_STATUS_SUCCESS, 
                                                   &m_sec_params);
            APP_ERROR_CHECK(err_code);
            break;
            
        case BLE_GATTS_EVT_SYS_ATTR_MISSING:
            err_code = sd_ble_gatts_sys_attr_set(m_conn_handle, NULL, 0);
            APP_ERROR_CHECK(err_code);
            break;

        case BLE_GAP_EVT_AUTH_STATUS:
            m_auth_status = p_ble_evt->evt.gap_evt.params.auth_status;
            break;
            
        case BLE_GAP_EVT_SEC_INFO_REQUEST:
            p_enc_info = &m_auth_status.periph_keys.enc_info;
            if (p_enc_info->div == p_ble_evt->evt.gap_evt.params.sec_info_request.div)
            {
                err_code = sd_ble_gap_sec_info_reply(m_conn_handle, p_enc_info, NULL);
                APP_ERROR_CHECK(err_code);
            }
            else
            {
                // No keys found for this device
                err_code = sd_ble_gap_sec_info_reply(m_conn_handle, NULL, NULL);
                APP_ERROR_CHECK(err_code);
            }
            break;

        case BLE_GAP_EVT_TIMEOUT:
            if (p_ble_evt->evt.gap_evt.params.timeout.src == BLE_GAP_TIMEOUT_SRC_ADVERTISEMENT)
            { 
                /*
								nrf_gpio_pin_clear(ADVERTISING_LED_PIN_NO);

                // Configure buttons with sense level low as wakeup source.
                nrf_gpio_cfg_sense_input(WAKEUP_BUTTON_PIN,
                                         BUTTON_PULL,
                                         NRF_GPIO_PIN_SENSE_LOW);
                
                // Go to system-off mode (this function will not return; wakeup will cause a reset)
                err_code = sd_power_system_off();    
                APP_ERROR_CHECK(err_code);
							*/
							 advertising_start();
            }
            break;

        default:
            // No implementation needed.
            break;
    }
}


/**@brief       Function for dispatching a S110 SoftDevice event to all modules with a S110
 *              SoftDevice event handler.
 *
 * @details     This function is called from the S110 SoftDevice event interrupt handler after a
 *              S110 SoftDevice event has been received.
 *
 * @param[in]   p_ble_evt   S110 SoftDevice event.
 */
static void ble_evt_dispatch(ble_evt_t * p_ble_evt)
{
    ble_conn_params_on_ble_evt(p_ble_evt);
    ble_nus_on_ble_evt(&m_nus, p_ble_evt);
    on_ble_evt(p_ble_evt);
}
#if 1
static void on_sys_evt(uint32_t sys_evt)
{
    switch(sys_evt)
    {
        case NRF_EVT_FLASH_OPERATION_SUCCESS:
        case NRF_EVT_FLASH_OPERATION_ERROR:
            if (m_memory_access_in_progress)
            {
                m_memory_access_in_progress = false;
                advertising_start();
            }
            break;
        default:
            // No implementation needed.
            break;
    }
}
#endif

#if 0
void ble_advertising_on_sys_evt(uint32_t sys_evt)
{
    uint32_t err_code = NRF_SUCCESS;
    switch (sys_evt)
    {

        case NRF_EVT_FLASH_OPERATION_SUCCESS:
        // Fall through.

        //When a flash operation finishes, advertising no longer needs to be pending.
        case NRF_EVT_FLASH_OPERATION_ERROR:
            if (m_advertising_start_pending)
            {
                m_advertising_start_pending = false;
                err_code = ble_advertising_start(m_adv_mode_current);
                if ((err_code != NRF_SUCCESS) && (m_error_handler != NULL))
                {
                    m_error_handler(err_code);
                }
            }
            break;

        default:
            // No implementation needed.
            break;
    }
}
#endif
static uint8_t                               m_advertising_mode;                        /**< Variable to keep track of when we are advertising. */

static void sys_evt_dispatch(uint32_t sys_evt)
{
    pstorage_sys_event_handler(sys_evt);
    //ble_advertising_on_sys_evt(sys_evt);
		on_sys_evt(sys_evt);
}

/**@brief   Function for the S110 SoftDevice initialization.
 *
 * @details This function initializes the S110 SoftDevice and the BLE event interrupt.
 */
static void ble_stack_init(void)
{
    // Initialize SoftDevice.
	//SOFTDEVICE_HANDLER_INIT(NRF_CLOCK_LFCLKSRC_SYNTH_250_PPM, false);
	
  //SOFTDEVICE_HANDLER_INIT(NRF_CLOCK_LFCLKSRC_XTAL_20_PPM, false);
	SOFTDEVICE_HANDLER_INIT(NRF_CLOCK_LFCLKSRC_RC_250_PPM_250MS_CALIBRATION, false);
    
    // Subscribe for BLE events.
    uint32_t err_code = softdevice_ble_evt_handler_set(ble_evt_dispatch);
    APP_ERROR_CHECK(err_code);
		//wtd add 
		err_code = softdevice_sys_evt_handler_set(sys_evt_dispatch);
		APP_ERROR_CHECK(err_code);
}

/**@brief  Function for configuring the buttons.
 */
static void buttons_init(void)
{
//    nrf_gpio_cfg_sense_input(WAKEUP_BUTTON_PIN,
//                             BUTTON_PULL, 
//                             NRF_GPIO_PIN_SENSE_LOW);    
		APP_GPIOTE_INIT(1);
			
		static app_button_cfg_t buttons[] =
    {
        {5, false, BUTTON_PULL, button_event_handler}
     };
    
    APP_BUTTON_INIT(buttons, sizeof(buttons) / sizeof(buttons[0]), BUTTON_DETECTION_DELAY, false);	
		 app_button_enable();
}

static void button_event_handler(uint8_t pin_no, uint8_t button_action)
{
    if (button_action == APP_BUTTON_PUSH)
    {
        switch (pin_no)
        {
            case 5:
                button_handle();
						simple_uart_putstring((const uint8_t *)"1");
                break;        
            default:
                APP_ERROR_HANDLER(pin_no);
                break;
        }
    }   
simple_uart_putstring((const uint8_t *)"1");		
}

void button_handle(void)
{
		if(nrf_gpio_pin_read(3))
				nrf_gpio_pin_clear(3);
				else
				nrf_gpio_pin_set(3);
}
/**@brief  Function for placing the application in low power state while waiting for events.
 */
static void power_manage(void)
{
    uint32_t err_code = sd_app_evt_wait();
    APP_ERROR_CHECK(err_code);
}


/**@brief  Function for initializing the UART module.
 */
static void uart_init(void)
{
    /**@snippet [UART Initialization] */
    //simple_uart_config(RTS_PIN_NUMBER, TX_PIN_NUMBER, CTS_PIN_NUMBER, RX_PIN_NUMBER, HWFC);
    simple_uart_config(0, 8, 0, 9, 0);
    NRF_UART0->INTENSET = UART_INTENSET_RXDRDY_Enabled << UART_INTENSET_RXDRDY_Pos;
    
    NVIC_SetPriority(UART0_IRQn, APP_IRQ_PRIORITY_LOW);
    NVIC_EnableIRQ(UART0_IRQn);
    /**@snippet [UART Initialization] */
}


/**@brief   Function for handling UART interrupts.
 *
 * @details This function will receive a single character from the UART and append it to a string.
 *          The string will be be sent over BLE when the last character received was a 'new line'
 *          i.e '\n' (hex 0x0D) or if the string has reached a length of @ref NUS_MAX_DATA_LENGTH.
 */
void UART0_IRQHandler(void)
{
    static uint8_t data_array[BLE_NUS_MAX_DATA_LEN];
    static uint8_t index = 0;
    uint32_t err_code;

    /**@snippet [Handling the data received over UART] */

    data_array[index] = simple_uart_get();
    index++;

    if ((data_array[index - 1] == '\n') || (index >= (BLE_NUS_MAX_DATA_LEN - 1)))
    {
        err_code = ble_nus_send_string(&m_nus, data_array, index + 1);
        if (err_code != NRF_ERROR_INVALID_STATE)
        {
            APP_ERROR_CHECK(err_code);
        }
        
        index = 0;
    }

    /**@snippet [Handling the data received over UART] */
}

void led_on(uint16_t delay_s)
{
		led_on_time = delay_s*2;
}
void led_oning_deal_1s(void)
{
		
}
void led_flash(uint16_t delay_s)
{
		led_flash_time = delay_s*2;
}
void led_flash_deal_500ms(void)
{
		if(led_on_time > 0)
		{	
				nrf_gpio_pin_set(2);	
				led_on_time--;
		}
		
		if(led_flash_time > 0)
		{	
				if(nrf_gpio_pin_read(2))
				nrf_gpio_pin_clear(2);
				else
				nrf_gpio_pin_set(2);
				
				led_flash_time--;
		}
		if((led_flash_time==0)&&(led_on_time == 0))
		{	nrf_gpio_pin_clear(2);	}
		
}

void TIMER1_1s_deal(void)
{
		led_oning_deal_1s();
}
void TIMER1_500ms_deal(void)
{
		led_flash_deal_500ms();
}
void cash_control_for(void)
{
	
//		if(cash_control == 1)
//		{
//				nrf_gpio_pin_set(11);
//				nrf_gpio_pin_set(12);
//				simple_uart_putstring((const uint8_t *)"Cash open !!! \n\r");
//				cash_control = 0;
//		}
//		else if(cash_control == 0)
//		{
//				nrf_gpio_pin_clear(11);
//				nrf_gpio_pin_clear(12);
//				cash_control = 0;
//		}
		
				
		if(cash_control == 1)
		{
				nrf_gpio_pin_set(11);
				nrf_gpio_pin_set(12);
				simple_uart_putstring((const uint8_t *)"Cash open !!! \n\r");
				cash_control = 3;
		}
		else if(cash_control == 3)
		{
				nrf_gpio_pin_clear(11);
				cash_control = 4;
		}
		else if(cash_control == 0)
		{
				nrf_gpio_pin_clear(11);
				nrf_gpio_pin_clear(12);
				cash_control = 0;
		}		

}

void TIMER1_IRQHandler(void)   
{   
		if(NRF_TIMER1->EVENTS_COMPARE[0]==1 )NRF_TIMER1->EVENTS_COMPARE[0]=0;
		
		TIMER1_500ms_counter++;
		if(TIMER1_500ms_counter >= 10)
		{
				TIMER1_500ms_counter = 0;
				TIMER1_1000ms_counter++;
				TIMER1_500ms_deal();
		}
		if(TIMER1_1000ms_counter >= 2)
		{
				TIMER1_1000ms_counter = 0;
				SystemTimer++;
				TIMER1_1s_deal();
		}
		

		if(cash_control == 2)
			{
					nrf_gpio_pin_set(12);
					cash_control = 3;
			}
			if(cash_control == 4)
			{
					nrf_gpio_pin_clear(12);
					cash_control = 0;
			}
		TIMER1_200ms_counter++;
		if(TIMER1_200ms_counter >= 5)
		{
			TIMER1_200ms_counter = 0;

			cash_control_for();

		}

}

void Timer_1_init(void)
{
		uint32_t val;
		NRF_CLOCK->EVENTS_HFCLKSTARTED = 0;
		NRF_CLOCK->TASKS_HFCLKSTART = 1;
		while (NRF_CLOCK->EVENTS_HFCLKSTARTED == 0)
		{
		}
		NRF_TIMER1->MODE = TIMER_MODE_MODE_Timer;//定时模式
		NRF_TIMER1->BITMODE  = TIMER_BITMODE_BITMODE_16Bit;  //定时器位宽
		NRF_TIMER1->PRESCALER   = 9;  //预分频，f=16/2^(prescale),最大为9，即512分频
		NRF_TIMER1->TASKS_CLEAR = 1; 	//清除任务
		val = (50*31) + (50/4);
		NRF_TIMER1->CC[0] = val;
		NRF_TIMER1->TASKS_CAPTURE[0] = 0;	
		NRF_TIMER1->TASKS_START = 1;     
		NRF_TIMER1->SHORTS  =(TIMER_SHORTS_COMPARE0_CLEAR_Enabled );
		NRF_TIMER1->INTENSET  = (TIMER_INTENSET_COMPARE0_Enabled << TIMER_INTENSET_COMPARE0_Pos); 
		NVIC_SetPriority(TIMER1_IRQn,APP_IRQ_PRIORITY_HIGH); 
		NVIC_EnableIRQ(TIMER1_IRQn);
		
}
/**@brief  Application main function.
 */


static void pstorage_callback_handler(pstorage_handle_t * handle, uint8_t op_code, uint32_t result, uint8_t * p_data, uint32_t data_len)
{
    // If we are in BOOTLOADER_SETTINGS_SAVING state and we receive an PSTORAGE_STORE_OP_CODE 
    // response then settings has been saved and update has completed.
    APP_ERROR_CHECK(result);
}
void setting_init(void)
{
    uint32_t                err_code = NRF_SUCCESS;
		pstorage_module_param_t storage_params;
		static pstorage_handle_t        m_bootsettings_handle;

    storage_params.cb          = pstorage_callback_handler;
    storage_params.block_size  = sizeof(bootloader_settings_t);
    storage_params.block_count = 1;
    
    err_code = pstorage_init();
    if (err_code != NRF_SUCCESS)    
    {
        return ;
    }

    err_code = pstorage_register(&storage_params, &m_bootsettings_handle);
    if (err_code != NRF_SUCCESS)    
    {
        return ;
    }

		(void) pstorage_load((uint8_t *) &bootloader_settings, &m_bootsettings_handle, sizeof(bootloader_settings_t), 0);
}
void cash_box_init()
{
		nrf_gpio_cfg_output(11); 														//12v en
		nrf_gpio_cfg_output(12); 														//cash open
		nrf_gpio_cfg_input( 15,NRF_GPIO_PIN_PULLUP); 				//cash det
		simple_uart_putstring((const uint8_t *)"cash box init ...\n\r");
}

//wtd add 
#define PRIVATE_PASSWD_LEN 64
int my_flag = 0;
pstorage_handle_t m_data_num_handle; //flash

static void my_cb(pstorage_handle_t *p_handle,uint8_t op_code,uint32_t result,uint8_t *p_data,uint32_t data_len)
{
	switch(op_code)
	{
		case PSTORAGE_CLEAR_OP_CODE:
			if(result == NRF_SUCCESS)
			{
				simple_uart_putstring((const uint8_t *)"PSTORAGE_CLEAR SUCCESS\n\r"); 
			}
			else
			{
				//update operation failed
				simple_uart_putstring((const uint8_t *)"PSTORAGE_CLEAR FAIL\n\r"); 
			}
			
			case PSTORAGE_STORE_OP_CODE:
			if(result == NRF_SUCCESS)
			{
				simple_uart_putstring((const uint8_t *)"PSTORAGE_STORE SUCCESS\n\r"); 
			}
			else
			{
				//update operation failed
				simple_uart_putstring((const uint8_t *)"PSTORAGE_STORE FAIL\n\r"); 
			}
			
			case PSTORAGE_LOAD_OP_CODE:
			if(result == NRF_SUCCESS)
			{
				simple_uart_putstring((const uint8_t *)"PSTORAGE_LOAD SUCCESS\n\r"); 
			}
			else
			{
				//update operation failed
				simple_uart_putstring((const uint8_t *)"PSTORAGE_LOAD FAIL\n\r"); 
			}
			break;
	}
}

void flash_private_passwd_init()
{
	uint32_t err_code;
	pstorage_module_param_t module_param;
	module_param.block_count = 1;
	module_param.block_size = PRIVATE_PASSWD_LEN;
	module_param.cb = my_cb;
	pstorage_init();//初始化FLASH操作
	err_code = pstorage_register(&module_param, &m_data_num_handle);
	if (NRF_SUCCESS != err_code)
	{
		simple_uart_putstring((const uint8_t *)"post111\n\r"); 
		return ;
	}
	APP_ERROR_CHECK(err_code);
}

void flash_test(void)
{
		 uint32_t err_code;
	__align(4)  uint8_t data[16]={"flash test!"};
	__align(4)  uint8_t read[16];
	 pstorage_handle_t       block_handle;
	err_code = pstorage_block_identifier_get(&m_data_num_handle, 0, &block_handle); //获取id
	APP_ERROR_CHECK(err_code);
	simple_uart_putstring((const uint8_t *)"test 111\n\r");	
	//擦除
	err_code = pstorage_clear(&block_handle, PRIVATE_PASSWD_LEN);
	if(err_code != NRF_SUCCESS)
	{
		simple_uart_putstring((const uint8_t *)"pstorage_clear ERROR\n\r");	
	}
	APP_ERROR_CHECK(err_code);
	simple_uart_putstring((const uint8_t *)"test 222\n\r");	
	 //写入数据 14byte,off=0
	err_code=pstorage_store(&block_handle,data,16,0);
	APP_ERROR_CHECK(err_code);
	simple_uart_putstring((const uint8_t *)"test 333\n\r"); 
	//读取数据 14byte
	err_code=pstorage_load(read,&block_handle,16,0);
	APP_ERROR_CHECK(err_code);
	simple_uart_putstring((const uint8_t *)read);  
	 //打印数据
  printf("read=%s\r\n",read);
}

int main(void)
{
		uart_init();
    leds_init();
		timers_init();
    buttons_init();
		cash_box_init();
		Timer_1_init();
	  setting_init();

		led_on(3);
		              nrf_gpio_cfg_sense_input(5,
                                         BUTTON_PULL, 
                                         NRF_GPIO_PIN_SENSE_LOW);	
		simple_uart_putstring((const uint8_t *)START_STRING);
		ble_stack_init();
		flash_private_passwd_init(); 
    gap_params_init();
		services_init();
    advertising_init();
    conn_params_init();
    sec_params_init();   
    advertising_start();
		simple_uart_putstring((const uint8_t *)"test 0");
		flash_test();
    for (;;)
    {
        power_manage();
    }
}

/*******************************************************************************
*   BLE 升级通讯
*******************************************************************************/
uint8_t csum(uint8_t *addr, uint8_t count)
{
           /* Compute Internet Checksum for "count" bytes
            *         beginning at location "addr".
            */
       uint8_t sum = 0;
 
       while( count > 1 )  {
           /*  This is the inner loop */
               sum += *addr++;
               count -= 1;
       }
 
       return sum;
}

void update_ack(int num )
{
		uint32_t err_code;
		uint8_t val[20]={0};
		
		val[0] = 0xA0|0x05;
		val[1] = num>>8;
		val[2] = num;
		
		val[3] = 'u';
		val[4] = 'p';
		val[5] = 'a';
		val[6] = 'c';
		val[7] = 'k';
		
		
		val[8] =csum(val,8);
		
		err_code = ble_nus_send_string(&m_nus, val, 8);
		if (err_code != NRF_ERROR_INVALID_STATE)
    {
            APP_ERROR_CHECK(err_code);
    }
}

void cash_status_ack(void )
{
		uint32_t err_code;
		uint8_t val[20]={0};
	
		
		val[0] = 's';
		val[1] = 't';
		val[2] = 'u';
		val[3] = ':';
		
		if(nrf_gpio_pin_read(15))
		{
				val[4] = 'o';
				val[5] = 'n';
				val[6] = ' ';
		}
		else
		{
				val[4] = 'o';
				val[5] = 'f';
				val[6] = 'f';
		}
		
		err_code = ble_nus_send_string(&m_nus, val, 7);
		if (err_code != NRF_ERROR_INVALID_STATE)
    {
            APP_ERROR_CHECK(err_code);
    }
}

